<?php
	include("data/includes/BEncode.php");
	
	function unesc($x) {
    	if (get_magic_quotes_gpc())
		  return stripslashes($x);
		return $x;
	}
	
	function hex2bin($hexdata) {
		$bindata = "";
		for ($i=0;$i<strlen($hexdata);$i+=2) {
			$bindata.=chr(hexdec(substr($hexdata,$i,2)));
		}
		return $bindata;
}


	function connect($server, $user, $pw, $db) {
		switch (DBT) {
			case "PostgreSQL":
				$res = @pg_pconnect("host=$server user=$user password=$pw port=5432 dbname=$db");
				if ( pg_last_error() ) bterror("pgSQL-error: ". pg_last_error());
			break;
			case "MySQL":
	            $res = @mysql_pconnect($server,$user,$pw);
				if ( mysql_error() ) bterror("mySQL-error: ". mysql_error());
	            @mysql_select_db($db);
				if ( mysql_error() ) {
					bterror("mySQL-error: ". mysql_error());
				}
			break;
		}
		return $res;
	}

	function query($handle, $query) {
		switch (DBT) {
			case "PostgreSQL":
				$res = @pg_query($handle, "$query");
				if ( pg_last_error() ) bterror("pgSQL-error: ". pg_last_error());
			break;
			case "MySQL":
				$res = @mysql_query("$query");
				if ( mysql_error() ) bterror("mySQL-error: ". mysql_error());
			break;
		}
		return $res;
	}
	
	function fetch_object($handler) {
		switch (DBT) {
			case "PostgreSQL":
				$res = @pg_fetch_object($handler);
				if ( pg_last_error() ) bterror("pgSQL-error: ". pg_last_error());
			break;
			case "MySQL":
				$res = @mysql_fetch_object($handler);
				if ( mysql_error() ) bterror("mySQL-error: ". mysql_error());
			break;
		}
		return $res;
	}
	
	function fetch_array($handler) {
		switch (DBT) {
			case "PostgreSQL":
				$res = @pg_fetch_array($handler);
				if ( pg_last_error() ) bterror("pgSQL-error: ". pg_last_error());
			break;
			case "MySQL":
				$res = @mysql_fetch_array($handler);
				if ( mysql_error() ) bterror("mySQL-error: ". mysql_error());
			break;
		}
		return $res;
	}
	
	function num_rows($handler) {
		switch (DBT) {
			case "PostgreSQL":
				$res = @pg_num_rows($handler);
				if ( pg_last_error() ) bterror("pgSQL-error: ". pg_last_error());
			break;
			case "MySQL":
				$res = @mysql_num_rows($handler);
				if ( mysql_error() ) bterror("mySQL-error: ". mysql_error());
			break;
		}
		return $res;
	}
	
	function escape_string($in) {
		switch (DBT) {
			case "PostgreSQL":
				$res = pg_escape_string($in);
			break;
			case "MySQL":
				$res = mysql_escape_string($in);
			break;
		}
		return $res;
	}

	function bterror($message) {
		$error["failure reason"] = $message;
		die(BEncode($error));
	}
	
	function getkeys($req) {
		$res = array();
		foreach ( explode(":", $req) as $x ) {
			if ($x[0] == "!") {
				$x = substr($x, 1);
				$opt = 1;
			}
			else
				$opt = 0;
			if ( !isset($_GET[$x]) ) {
				if ( !$opt ) bterror("missing key $x");
				continue;
			}
			$res[$x] = unesc($_GET[$x]);
		}
		return $res;
	}
	
	function checklen($keys, $key, $len) {
		if ( strlen($keys[$key]) != 20 ) bterror("length of $key != 20");
	}
	
	function checkclient($dbh, $agent) {
		global $disallowed;
		$dislist = split(",", $disallowed);
		foreach($dislist as $ag) {
			$ag = strtolower($ag);
			
			$pos = strpos($agent, $ag);
			if ($pos === false) { 
				//Allowed Client
			} else {
				bterror("$ag is not allowed on this tracker!");
			}
		}
	}

	function newtorrent($dbh, $dechash) {
		global $acttime;
		$result = query($dbh, "insert into tracker_content (hash, stamp, peer_pid) VALUES ('$dechash', '$acttime', 'base')");
	}
	
	function cleandupepeers($dbh) {
		global $ipaddr, $dechash, $decpeer;
		$result = query($dbh, "SELECT seeder, leecher, complete FROM tracker_content WHERE hash='$dechash' AND peer_pid='base'");
		$olddat = fetch_array($result);
		$ipcheck = query($dbh, "SELECT id, peer_status FROM tracker_content WHERE hash='$dechash' AND peer_pid!='base' AND peer_pid!='$decpeer' AND peer_ip='$ipaddr'", false);
		if ( $ipcheck ) {
			$seed = doubleval($olddat["seeder"]);
			$leech = doubleval($olddat["leecher"]);
			$complete = doubleval($olddat["complete"]);
			while ( $iprow = fetch_object($ipcheck) ) {
				if ( $iprow->peer_status == "seeding" ) {
					$seed = $seed - 1;
				} elseif ( $iprow->peer_status == "leeching" ) {
					$leech = $leech - 1;
				}
				$id = $iprow->id;
				query($dbh, "UPDATE tracker_content SET seeder='$seed', leecher='$leech' WHERE hash='$dechash' AND peer_pid='base'");
				query($dbh, "DELETE FROM tracker_content WHERE id='$id'");
				query ($dbh, "UPDATE torrents SET tr_complete='$seed', tr_incomplete='$leech', tr_downloaded='$complete' WHERE hash='$enchash'");
			}
		}
	}
	
	function newpeer ( $dbh, $keys ) {
		global $status, $dechash, $enchash, $decpeer, $acttime, $ipaddr;
		
		$port = intval($keys["port"]);
		$up = doubleval($keys["uploaded"]);
		$down = doubleval($keys["downloaded"]);
		$left = doubleval($keys["left"]);
		
		switch ($status) {
			case "seeding":
				$yesno = "yes";
			break;
			case "leeching":
				$yesno = "no";
			break;
		}
		
		$sql =	"INSERT INTO tracker_content ".
				"( hash, peer_pid, peer_ip, peer_port, peer_uploaded, ".
				"peer_downloaded, peer_left, peer_stamp, peer_status, peer_completed ) VALUES ".
				"( '$dechash', '$decpeer', '$ipaddr', '$port', '$up', ".
				"'$down', '$left', '$acttime', '$status', '$yesno' )";
		query($dbh, $sql);
		
		// update tracker-stats
		updatestats($dbh);
	}
	
	function updatepeer ( $dbh, $keys ) {
		global $status, $dechash, $decpeer, $acttime, $ipaddr;
		
		$port = intval($keys["port"]);
		$up = doubleval($keys["uploaded"]);
		$down = doubleval($keys["downloaded"]);
		$left = doubleval($keys["left"]);

		$ergebnis = query($dbh, "SELECT peer_uploaded, peer_downloaded FROM tracker_content WHERE hash='$dechash' AND peer_pid='$decpeer'");
		$trackerdat = fetch_array($ergebnis);
		$ergebnis = query($dbh, "SELECT tr_up, tr_down FROM users WHERE ipaddr='$ipaddr' AND name!='guest'");
		$userdat = fetch_array($ergebnis);
		
		if ( $up > $trackerdat["peer_uploaded"] ) {
			$upadd = $up - $trackerdat["peer_uploaded"];
		} else {
			$upadd = 0;
		}
		if ( $down > $trackerdat["peer_downloaded"] ) {
			$downadd = $down - $trackerdat["peer_downloaded"];
		} else {
			$downadd = 0;
		}
		$newup = $userdat["tr_up"] + $upadd;
		$newdown = $userdat["tr_down"] + $downadd;
		query($dbh, "UPDATE users SET tr_up='$newup', tr_down='$newdown' WHERE ipaddr='$ipaddr' AND name!='guest'");
		
		$sql =	"UPDATE tracker_content SET ".
				"peer_ip = '$ipaddr', peer_port = '$port', ".
				"peer_uploaded = '$up', peer_downloaded = '$down', ".
				"peer_left = '$left', peer_stamp = '$acttime', ".
				"peer_status = '$status' WHERE hash='$dechash' AND peer_pid='$decpeer'";
		query($dbh, $sql);
		// update tracker-stats
		updatestats($dbh);
	}
	
	function updatestats($dbh) {
		global $dechash, $enchash;
		$result = query($dbh, "SELECT null FROM tracker_content WHERE hash='$dechash' AND peer_pid!='base' AND peer_status='seeding'");
		$aktseed = num_rows($result);
		$result = query($dbh, "SELECT null FROM tracker_content WHERE hash='$dechash' AND peer_pid!='base' AND peer_status='leeching'");
		$aktleech = num_rows($result);
		query($dbh, "UPDATE tracker_content SET seeder='$aktseed', leecher='$aktleech' WHERE hash='$dechash' AND peer_pid='base'");
		$result = query($dbh, "SELECT complete FROM tracker_content WHERE hash='$dechash' AND peer_pid='base'");
		$crow = fetch_object($result);
		$complete = $crow->complete;
		query($dbh, "UPDATE torrents SET tr_incomplete='$aktleech', tr_complete='$aktseed', tr_downloaded='$complete' WHERE hash='$enchash'");
	}

	function checkevent ( $dbh, $event ) {
		global $dechash, $decpeer, $status, $enchash;
		$res = false;		
		// verschiedene events auswerten
		// (was ist mit "started"?)
		switch ( $event ) {
			case "stopped":
				query($dbh, "DELETE FROM tracker_content WHERE hash='$dechash' AND peer_pid='$decpeer'");
				updatestats($dbh);
				$res = true;
			break;
			case "completed":
				$result = query($dbh, "SELECT complete FROM tracker_content WHERE hash='$dechash' AND peer_pid='base'");
				$row = fetch_array($result);
				$newcomp = doubleval($row["complete"]) + 1;
				query($dbh, "UPDATE tracker_content SET complete='$newcomp' WHERE hash='$dechash' AND peer_pid='base'");
				query($dbh, "UPDATE torrents SET tr_downloaded='$newcomp' WHERE hash='$enchash'");
				query($dbh, "UPDATE tracker_content SET peer_left='0', peer_status='seeding', peer_completed='yes' WHERE hash='$dechash' AND peer_pid='$decpeer'");
				$res = true;
			break;
		}
		return $res;
	}
	
	function checkpeer( $dbh, $keys ) {
		global $status, $dechash, $decpeer;

		// check if peer is allready known
		$result = query($dbh, "SELECT null FROM tracker_content WHERE hash='$dechash' AND peer_pid='$decpeer'");
		if ( num_rows($result) > 0 ) {
			// allready known peer
			$res = true;
		} else {
			// new peer for this torrent
			$res = false;
		}
		return $res;
	}
	
	function deloldpeers($dbh) {
		global $acttime;
		$checktime = doubleval($acttime) - 3600;
		$hashes = query($dbh, "SELECT hash, seeder, leecher FROM tracker_content WHERE peer_pid='base'");
		while ( $hrow = fetch_object($hashes) ) {
			$hash = $hrow->hash;
			$oldseed = doubleval($hrow->seeder);
			$oldleech = doubleval($hrow->leecher);
			$lessseed = 0;
			$lessleech = 0;
			$count = query($dbh, "SELECT peer_status FROM tracker_content WHERE peer_stamp < '$checktime' AND hash = '$hash' AND peer_pid != 'base'");
			while ( $crow = fetch_object($count) ) {
				if ( $crow->peer_status == "seeding" ) $lessseed += 1;
				if ( $crow->peer_status == "leeching" ) $lessleech += 1;
			}
			$newseed = $oldseed - $lessseed;
			$newleech = $oldleech - $lessleech;
			query($dbh, "UPDATE tracker_content SET seeder='$newseed', leecher='$newleech' WHERE hash='$hash' AND peer_pid='base'");
		}
		query($dbh, "DELETE FROM tracker_content WHERE peer_stamp < '$checktime' AND peer_pid!='base'");
	}
	
	function sendpeers($dbh, $keys) {
		global $dechash, $maxsendpeer, $reportinterval, $minreport;
		
		// numwant und trackerid ueberpruefen
		if ( !$keys["numwant"] ) $numwant = $maxsendpeer; else $numwant = $keys["numwant"];
		if ( !$keys["trackerid"] ) $trackerid = 0; else $trackerid = $keys["trackerid"];
		
		// seeder- / leechercount auslesen
		$result = query($dbh, "SELECT seeder, leecher FROM tracker_content WHERE hash='$dechash' AND peer_pid='base'");
		$counts = fetch_array($result);

		// peers 2 send - counter
		$count = $maxsendpeer;
		if ($maxsendpeer > $numwant) {
			$count = $numwant;
		}
		
		// seeder peers auslesen
		switch (DBT) {
			case "MySQL":
				$result = query($dbh, "SELECT peer_ip, peer_pid, peer_port FROM tracker_content WHERE hash='$dechash' AND peer_status='seeding' AND peer_pid!='base' ORDER BY RAND() LIMIT $count");
			break;
			case "PostgreSQL":
				$result = query($dbh, "SELECT peer_ip, peer_pid, peer_port FROM tracker_content WHERE hash='$dechash' AND peer_status='seeding' AND peer_pid!='base' ORDER BY RANDOM() LIMIT $count");
			break;
		}
		
		if ( num_rows($result) <= 3 ) {
			// When less than 3 seeders, send leechers, too..
			switch (DBT) {
				case "MySQL":
				$result = query($dbh, "SELECT peer_ip, peer_pid, peer_port FROM tracker_content WHERE hash='$dechash' AND peer_pid!='base' ORDER BY RAND() LIMIT $count");
				break;
				case "PostgreSQL":
				$result = query($dbh, "SELECT peer_ip, peer_pid, peer_port FROM tracker_content WHERE hash='$dechash' AND peer_pid!='base' ORDER BY RANDOM() LIMIT $count");
				break;
			}
		}
		
		$peer["interval"] = intval($reportinterval);
		$peer["min interval"] = intval($minreport);
		$peer["num peers"] = intval($counts["leecher"]);
		
		$i = 0;
		while ( $db_peers = fetch_array($result) ) {
			$peer["peers"][(int)$i]["ip"] = $db_peers["peer_ip"];
			$peer["peers"][(int)$i]["port"] = intval($db_peers["peer_port"]);
			$peer["peers"][(int)$i]["peer id"] = hex2bin($db_peers["peer_pid"]);
			$i += 1;
		}
		if ( $trackerid != 0 ) $peer["trackerid"] = $trackerid;

		echo BEncode($peer);
	}
	
	function checkdelay($dbh, $ip) {
		global $enchash;
		$result = query ($dbh, "SELECT name, status FROM users WHERE ipaddr='$ip' AND name!='guest'");
		$irow = fetch_object($result);
		$user = $irow->name;
		$ustat = $irow->status;
		$result = query ( $dbh, "SELECT added FROM torrents WHERE hash='$enchash'");
		$trow = fetch_object($result);
		$added = $irow->added;
		$ud = query($dbh, "SELECT tr_up, tr_down FROM users WHERE name='$user'");
		$userdat = fetch_array($ud);
		$tr_up = doubleval($userdat["tr_up"]);
		$tr_down = doubleval($userdat["tr_down"]);
		if ( ( $tr_up > 0 ) AND ( $tr_down > 0 ) ) {
			$uratio = round($tr_up / $tr_down, 2);
		} else {
			if ( $tr_up > 0 ) $uratio = 99.99; else $uratio = 0.00;
		}		
		$delays = query($dbh, "SELECT delay, ratio FROM delays WHERE up<='$tr_up' ORDER BY up DESC");
		while ( $drow = fetch_object($delays) ) {
			if ( $uratio <= doubleval($drow->ratio) ) $delay = doubleval($drow->delay);
		}
		$wait = doubleval($acttime) - doubleval($added);
		$wait = round(($delay*3600 - $wait) / 3600, 2);
		if ( $ustat >= 200 ) $wait = 0;
		if ( $ratio == 0 ) $wait = 0;
		if ( $wait <= 0 ) $wait = "no";
		
		if ( $wait != "no" ) bterror("You will have to wait ". $wait ." more hours...");
	}
	
	function checkip($dbh, $ip) {
		$result = query($dbh, "SELECT ip FROM tracker_blacklist");
		while ( $blrow = fetch_object($result) ) {
			if ( $blrow->ip == $ip ) bterror("Your IP is blacklisted.");
		}
	}

	function checkuser($dbh, $ip) {
		global $yabtucurl, $levels, $noreg;
		$res = false;
		switch ( $noreg ) {
			case 0:
				$result = query ($dbh, "SELECT status FROM users WHERE ipaddr='$ip' AND name!='guest'");
				$irow = fetch_object($result);
				if ( $irow->status >= $levels["tracker"] ) $res = true;
			break;
			case 1:
				if ( $levels["tracker"] > 0 ) {
					$result = query ($dbh, "SELECT status FROM users WHERE ipaddr='$ip' AND name!='guest'");
					$irow = fetch_object($result);
					if ( $irow->status >= $levels["tracker"] ) $res = true;
				} else {
					$res = true;
				}
			break;
			case 2:
				$res = true;
			break;
		}
		if ( !$res ) bterror("Please login to the webinterface at ". $yabtucurl ." to use this tracker");
	}
		
	function checktorrent($dbh, $keys) {
		global $yabtucurl, $enchash, $dechash;
		
		// torrent known to yaBTuc ?
		$result = query($dbh, "SELECT null FROM torrents WHERE hash = '$enchash'");
		if ( num_rows($result) == 0 ) {
			bterror("Please first upload this torrent to $yabtucurl");
		}
		// torrent known to tracker ?
		$result = query($dbh, "SELECT null FROM tracker_content WHERE hash = '$dechash' AND peer_pid='base'");
		if ( num_rows($result) == 0 ) {
			// no - create new entry
			$res = false;
		} else {
			// yes - update entry
			$res = true;
		}

		return $res;
	}
?>